<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>iCelNNWeights Struct Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">iCelNNWeights Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="iCelNNWeights" --><!-- doxytag: inherits="iBase" -->
<p>Structure which can hold the weightings of all links between the nodes of an <a class="el" href="structiPcNeuralNet.html" title="A property class implementing a feed-forward neural network.">iPcNeuralNet</a> property class.  
 <a href="structiCelNNWeights.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="neuralnet_8h_source.html">propclass/neuralnet.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for iCelNNWeights:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structiCelNNWeights.png" usemap="#iCelNNWeights_map" alt=""/>
  <map id="iCelNNWeights_map" name="iCelNNWeights_map">
<area doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html" alt="iBase" shape="rect" coords="0,0,96,24"/>
</map>
 </div></div>

<p><a href="structiCelNNWeights-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr</a>&lt; <a class="el" href="structiCelNNWeights.html">iCelNNWeights</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelNNWeights.html#a502e28689deced562bb143409652fdc1">Clone</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a new structure which is a copy of this one.  <a href="#a502e28689deced562bb143409652fdc1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray</a>&lt; <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray</a><br class="typebreak"/>
&lt; <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray</a>&lt; float &gt; &gt; &gt; &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelNNWeights.html#afeff18d971cac76e166e172d5f849ef8">Data</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Access the weighting data (non-const). Use with care.  <a href="#afeff18d971cac76e166e172d5f849ef8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray</a>&lt; <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray</a><br class="typebreak"/>
&lt; <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray</a>&lt; float &gt; &gt; &gt; &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelNNWeights.html#a59cbe23d869193968a0490aafce4a7bb">Data</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Access the weighting data.  <a href="#a59cbe23d869193968a0490aafce4a7bb"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Structure which can hold the weightings of all links between the nodes of an <a class="el" href="structiPcNeuralNet.html" title="A property class implementing a feed-forward neural network.">iPcNeuralNet</a> property class. </p>
<p>This is not really intended to be used by user code, only by neural network training code like celPcEvolve.</p>
<p><a class="el" href="structiCelNNWeights.html#afeff18d971cac76e166e172d5f849ef8" title="Access the weighting data (non-const). Use with care.">Data()</a>[i][j][k] is the weighting from node k to node j at layer i.</p>
<dl class="warning"><dt><b>Warning:</b></dt><dd>You must only modify the contents of the innermost arrays. Meaning, you must not replace any outer array, for example <code><a class="el" href="structiCelNNWeights.html#afeff18d971cac76e166e172d5f849ef8" title="Access the weighting data (non-const). Use with care.">Data()</a>[i] = myArray</code> to replace an entire layer. If you do, you will cause memory allocation problems. You must instead copy each individual float value separately. </dd></dl>

<p>Definition at line <a class="el" href="neuralnet_8h_source.html#l00049">49</a> of file <a class="el" href="neuralnet_8h_source.html">neuralnet.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a502e28689deced562bb143409652fdc1"></a><!-- doxytag: member="iCelNNWeights::Clone" ref="a502e28689deced562bb143409652fdc1" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr</a>&lt;<a class="el" href="structiCelNNWeights.html">iCelNNWeights</a>&gt; <a class="el" href="structiCelNNWeights.html#a502e28689deced562bb143409652fdc1">iCelNNWeights::Clone</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns a new structure which is a copy of this one. </p>

</div>
</div>
<a class="anchor" id="afeff18d971cac76e166e172d5f849ef8"></a><!-- doxytag: member="iCelNNWeights::Data" ref="afeff18d971cac76e166e172d5f849ef8" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray</a>&lt; <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray</a>&lt; <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray</a>&lt;float&gt; &gt; &gt;&amp; <a class="el" href="structiCelNNWeights.html#afeff18d971cac76e166e172d5f849ef8">iCelNNWeights::Data</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Access the weighting data (non-const). Use with care. </p>

</div>
</div>
<a class="anchor" id="a59cbe23d869193968a0490aafce4a7bb"></a><!-- doxytag: member="iCelNNWeights::Data" ref="a59cbe23d869193968a0490aafce4a7bb" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray</a>&lt; <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray</a>&lt; <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray</a>&lt;float&gt; &gt; &gt;&amp; <a class="el" href="structiCelNNWeights.html#afeff18d971cac76e166e172d5f849ef8">iCelNNWeights::Data</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Access the weighting data. </p>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li>propclass/<a class="el" href="neuralnet_8h_source.html">neuralnet.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
